#include "FormatStrings.def.h"

resource 'cmdo' (128) {
	{
		/*
		** Main dialog
		*/
		290,
		"Reformats C/C++ source into a standard format, "
		"suitable for printouts or compilation.  Reads from "
		"a file or standard in and writes to standard out.",
		{
			NotDependent {},
			VersionDialog {
				VersionString {"v1.0"},
				"Indent 1.0",
				noDialog
			},

			NotDependent {},
			NestedDialog {
				2,
				{24, 10, 43, 161},
				"I/O Specifications",
				"Click this button to specify Indent's input/output "
				"files and options."
			},

			/*
			** Styles
			*/
			NotDependent {},
			RadioButtons {
				{
					{67, 12, 102, 130},
					"K&R style",
					"",
					Set,
					"Format in the second edition K&R C style"
				},
			},

			NotDependent {},
			TextBox {
				black,
				{60, 10, 105, 161},
				"Styles"
			},


			/*
			** Line breaks
			*/
			NotDependent {},
			RadioButtons {
				{
					{123, 12, 138, 158},
					"Keep blank lines",
					"",
					Set,
					"Preserve blank lines from the source.  If set, a "
					"single newline "
					"is ignored, but two or more newlines appearing in "
					"sequence will be passed through to the output.",

					{143, 12, 158, 158},
					"Keep all newlines",
					"-allnl",
					NotSet,
					"Preserve source newlines.  If set, then newlines in the "
					"source are preserved.  Otherwise the source is completely "
					"reformatted.",

					{163, 12, 178, 158},
					"Keep no newlines",
					"-nonl",
					NotSet,
					"No source newlines will be passed through.  If set, only "
					"glue generated newlines will appear in the output.",
				},
			},

			NotDependent {},
			TextBox {
				black,
				{116, 10, 180, 161},
				"Spacing"
			},


			/*
			** Spacing
			*/
			NotDependent {},
			CheckOption {
				NotSet,
				{31, 166, 46, 315},
				"None around ops",
				"-x",
				"Suppress space around arithmetic ops +, "
				"-, *, /, %, relation ops ==, !=, <, <=, >, >=.  "
				"Normally 1 space is placed on each side."
			},

			NotDependent {},
			CheckOption {
				NotSet,
				{46, 166, 61, 315},
				"None around =",
				"-y",
				"Suppress space around assignment operator \"=\""
			},

			NotDependent {},
			CheckOption {
				NotSet,
				{61, 166, 76, 315},
				"None after commas",
				"-z",
				"Suppress space after commas."
			},

			NotDependent {},
			TextBox {
				black,
				{24, 164, 79, 317},
				"Spacing"
			},


			/*
			** Indent and line length
			*/
			NotDependent {},
			RegularEntry {
				"Indent value",
				{98, 167, 113, 277},
				{98, 280, 113, 310},
				"4",
				ignoreCase,
				"-indent",
				"Specifies the amount amount of tab for each indentation level."
			},

			NotDependent {},
			RegularEntry {
				"Line length",
				{118, 167, 133, 277},
				{118, 280, 133, 310},
				"144",
				ignoreCase,
				"-ll",
				"Set the output line width."
			},

			NotDependent {},
			RegularEntry {
				"Tab width",
				{138, 167, 153, 277},
				{138, 280, 153, 310},
				"4",
				ignoreCase,
				"-t",
				"Set the tab width."
			},

			NotDependent {},
			RegularEntry {
				"Comments",
				{158, 167, 173, 277},
				{158, 280, 173, 310},
				"48",
				ignoreCase,
				"-cc",
				"Set the column for end of line comments."
			},

			NotDependent {},
			TextBox {
				black,
				{87, 164, 180, 317},
				"Indenting"
			},

			/*
			** Glue formats
			*/
			NotDependent {},
			NestedDialog {
				3,
				{39, 323, 58, 467},
				"Function glue",
				"Modify the glue for function definitions"
			},

			NotDependent {},
			NestedDialog {
				4,
				{61, 323, 80, 467},
				"Method glue",
				"Modify the glue for method definitions"
			},

			NotDependent {},
			NestedDialog {
				5,
				{83, 323, 102, 467},
				"Declaration glue",
				"Modify the glue for declarations"
			},

			NotDependent {},
			NestedDialog {
				6,
				{105, 323, 124, 467},
				"Statement glue",
				"Modify the glue for executable statements and labels"
			},

			NotDependent {},
			NestedDialog {
				7,
				{127, 323, 146, 467},
				"Expression glue",
				"Modify the glue for expressions and function calls"
			},

			NotDependent {},
			TextBox {
				black,
				{24, 320, 180, 470},
				"Nerd glue"
			},
		},


		/* #2
		**	Dialog for I/O specification
		*/
		273,
		"I/O Specifications.",
		{	/* array itemArray */

			NotDependent {},
			RadioButtons {
				{	/* array radioArray: 2 elements */
					/* [1] */
					{13, 10, 28, 142}, "File to format:", "", Set, "Input file to be reformatted.  Standard "
					"input is not used in this case.",
					/* [2] */
					{13, 213, 28, 353}, "Redirect Standard", "", NotSet, "If the standard input file is used, then"
					" the reformatted file is always written "
					"to standard output."
				}
			},

			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					4097
				}
			},
			Files {
				InputFile,
				OptionalFile {
					{29, 29, 48, 29},
					{29, 29, 48, 146},
					"",
					"",
					"",
					"",
					"Specify the C/C++ source file to be reformatted.",
					dim,
					"Use Standard Input",
					"Select file to format...",
					""
				},
				Additional {
					"",
					".cp",
					"Only files ending in .cp",
					"All text files",
					{	/* array TypesArray: 1 elements */
						/* [1] */
						text
					}
				}
			},

			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					8193
				}
			},
			Redirection {
				StandardInput,
				{13, 353}
			},

			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					-6
				}
			},
			Redirection {
				StandardOutput,
				{50, 353}
			},

			NotDependent {},
			Redirection {
				DiagnosticOutput,
				{87, 353}
			},

			And {
				{	/* array AndArray: 2 elements */
					/* [1] */
					2,
					/* [2] */
					-4
				}
			},
			Files {
				OutputFile,
				OptionalFile {
					{50, 193, 65, 266},
					{66, 193, 85, 309},
					"Output File",
					"Standard Output",
					"",
					"",
					"Formatted output is written to the specified "
					"file.  If this file is not specified "
					"standard output is used.",
					dim,
					"Output to Standard Output File",
					"Specify file for formatted output...",
					""
				},
				NoMore {}
			},

			NotDependent {},
			CheckOption {
				NotSet,
				{107, 12, 122, 159},
				"Progress",
				"-p",
				"Display Indent's version and progress information "
				"on the diagnostic file."
			},

			NotDependent {},
			CheckOption {
				NotSet,
				{122, 12, 137, 159},
				"Trace parser",
				"-trace parse",
				"Display the actions the parser takes"
			},

			NotDependent {},
			CheckOption {
				NotSet,
				{137, 12, 152, 159},
				"Trace glue",
				"-trace formatting",
				"Display the actions of the formatting glue"
			},
		},


		/* #3
		**	Dialog for function glue
		*/
		273,
		"Function glue",
		{
			NotDependent {},
			RegularEntry {
				"<type>  <name>",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_fundef2,
				ignoreCase,
				"-fundef2",
				"Specify the glue for that point between the type of the function "
				"and the name of the function.  The default is to emit a newline "
				"so that the name is the first thing on the line.",
			},
	
			NotDependent {},
			RegularEntry {
				"<name>  ( ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_fundef3,
				ignoreCase,
				"-fundef3",
				"Specify the glue for the '(' in the function header.  The "
				"default is to display the '(', set the indent to the position "
				"after the '(' and indicate that this is the beginning of a "
				"line for the declarations following."
			},
		
			NotDependent {},
			RegularEntry {
				"<name>  ( ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_fundef4,
				ignoreCase,
				"-fundef4",
				"Specify the glue for the ',' in the function's arguments.  The "
				"default is to display the ',' and put an optional blank after "
				"it.  If the ',' is the first item on a line, then the temporary "
				"indent is set to the column the comma is in."
			},
		
			NotDependent {},
			RegularEntry {
				"(  ) ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_fundef6,
				ignoreCase,
				"-fundef6",
				"Specify the glue for the ')' in the function header.  The "
				"default is to display the ')'"
			},

			NotDependent {},
			RegularEntry {
				"()  <decl>",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_fundef7,
				ignoreCase,
				"-fundef7",
				"Specify the glue to emit prior to each variable declaration "
				"in a pre-ANSI function definition.  The default is place each "
				"declaration flush left on a new line."
			},


			NotDependent {},
			RegularEntry {
				"()ɥ { ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_fundef11,
				ignoreCase,
				"-fundef11",
				"Specify the glue to emit for the opening curly in a function "
				"definition.  "
				"The default is to place the opening curly flush left on a "
				"newline with they body of the function indented."
			},

			NotDependent {},
			RegularEntry {
				"(){  } ",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_fundef12,
				ignoreCase,
				"-fundef12",
				"Specify the glue to emit for the closing curly in a function "
				"definition.  The default is to place the closing curly flush "
				"left on a newline with three blank lines following it."
			},
		},


		/* #4
		**	Dialog for method glue
		*/
		273,
		"Method glue",
		{
			NotDependent {},
			RegularEntry {
				"()  : ",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_fundef8,
				ignoreCase,
				"-fundef8",
				"Specify the glue to emit for the ':' in a method definition.  "
				"The default is to indent the ':' on a newline with all base class "
				"constructors, member variable initializations, and the body "
				"aligned with the ':'."
			},

			NotDependent {},
			RegularEntry {
				"() :   , ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_fundef10,
				ignoreCase,
				"-fundef10",
				"Specify the glue to emit for the comma in a method's list of "
				"initializers.  The default is emit the ',' and request a newline "
				"unless the comma is the first item on the line, in which case "
				"it will have a blank emitted after it."
			},

			NotDependent {},
			RegularEntry {
				"() :   { ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_fundef13,
				ignoreCase,
				"-fundef13",
				"Specify the glue to emit for the opening curly in a method "
				"definition.  "
				"The default is align the opening curly on a newline with the "
				"initial ':' "
				"and to have the body of the method aligned with the opening curly."
			},

			NotDependent {},
			RegularEntry {
				"() : {  } ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_fundef14,
				ignoreCase,
				"-fundef14",
				"Specify the glue to emit for the closing curly in a method definition.  "
				"The default is align the closing curly on a newline with the initial ':'."
			},
		},


		/* #5
		**	Dialog for declaration glue
		*/
		273,
		"Declaration glue",
		{
			NotDependent {},
			RegularEntry {
				" <decl>",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_decl0,
				ignoreCase,
				"-decl0",
				"Specify the glue to emit prior to doing a declaration.  The "
				"default is to request the declaration to begin on a newline "
				"and for any '*' and '&' to associate with the object being "
				"declared."
			},
			
			NotDependent {},
			RegularEntry {
				"ɥ , ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_decl1,
				ignoreCase,
				"-decl1",
				"The default action for a comma in a declaration is to emit "
				"the comma with a space following it."
			},
			
			NotDependent {},
			RegularEntry {
				"ɥ = ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_decl2,
				ignoreCase,
				"-decl2",
				"Specify the glue for the '=' in an initialization.  The default "
				"is to surround it with blanks."
			},
			
			NotDependent {},
			RegularEntry {
				"ɥ ( ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_decl3,
				ignoreCase,
				"-decl3",
				"Specify the glue for an open paren in a declaration.  The "
				"default is to emit it and align all items following it with "
				"the first item following it."
			},
			
			NotDependent {},
			RegularEntry {
				"(ɥ ) ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_decl11,
				ignoreCase,
				"-decl11",
				"Specify the glue for the closing paren in a declaration.  "
				"The default is to just emit it."
			},
			
			NotDependent {},
			RegularEntry {
				"=  { ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_decl5,
				ignoreCase,
				"-decl5",
				"Specify the glue for the opening curly of an aggregate "
				"initializer.  The default is to emit after the '=', align "
				"all items following within the opening curly and then "
				"request a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"={  { ",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_decl6,
				ignoreCase,
				"-decl6",
				"Specify the glue for an aggregate initializer within a "
				"an aggregate initializer.  The default is to emit it on a "
				"newline with contents following it."
			},
			
			NotDependent {},
			RegularEntry {
				"={{  } ",
				{24, 265, 39, 370},
				{24, 374, 39, 470},
				FORMATSTRING_decl7,
				ignoreCase,
				"-decl7",
				"Specify the glue for the inner closing curly of an aggregate "
				"initializer.  The default is to emit it as is."
			},
			
			NotDependent {},
			RegularEntry {
				"={ɥ , ",
				{44, 265, 59, 370},
				{44, 374, 59, 470},
				FORMATSTRING_decl8,
				ignoreCase,
				"-decl8",
				"Specify the glue for the comma separating components of an "
				"aggregate initializer.  The default is to emit it with a "
				"blank following it."
			},
			
			NotDependent {},
			RegularEntry {
				"={  } ",
				{64, 265, 79, 370},
				{64, 374, 79, 470},
				FORMATSTRING_decl9,
				ignoreCase,
				"-decl9",
				"Specify the glue for the closing curly of an aggregate "
				"initializer.  The default is to just emit it."
			},
			
			NotDependent {},
			RegularEntry {
				"<decl>  ; ",
				{84, 265, 99, 370},
				{84, 374, 99, 470},
				FORMATSTRING_decl10,
				ignoreCase,
				"-decl10",
				"Specify the glue for the semicolon terminating a declaration.  "
				"The default is to make it adjacent to the declaration, emit it "
				"and then request a newline to follow it."
			},

			NotDependent {},
			NestedDialog {
				8,
				{119, 310, 138, 415},
				"struct glue",
				"Modify the glue for struct/class/union/enum data type "
				"definition statements"
			},
		},


		/* #6
		**	Dialog for statement glue
		*/
		273,
		"Statement glue",
		{
			NotDependent {},
			RegularEntry {
				" <stmt>",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_stmt0,
				ignoreCase,
				"-stmt0",
				"Specify the glue to emit prior to an otherwise unclassified "
				"statement (such as a function call or assignment, one which "
				"doesn't begin with a reserved word).  The default is to place "
				"the statement at the beginning of a new line."
			},

			NotDependent {},
			RegularEntry {
				"<stmt>  ; ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_stmt1,
				ignoreCase,
				"-stmt1",
				"Specify the glue to emit for the ';' terminating a statement.  "
				"The default is to request a newline after the semicolon, with no "
				"blanks separating the ';' from the item on its left."
			},

			NotDependent {},
			RegularEntry {
				" label  : ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_label1,
				ignoreCase,
				"-label1",
				"Specify the glue to emit for a label.  The default is to "
				"place it flush left on a line by itself."
			},

			NotDependent {},
			RegularEntry {
				" goto ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_goto1,
				ignoreCase,
				"-goto1",
				"Specify the glue to emit for a goto statement.  The default "
				"is to place it at the beginning of a newline and place a blank "
				"after the word 'goto'."
			},

			NotDependent {},
			RegularEntry {
				" break ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_break1,
				ignoreCase,
				"-break1",
				"Specify the glue to emit for a break/continue statement.  The "
				"default is to place it on a line by itself."
			},

			NotDependent {},
			RegularEntry {
				" return ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_return1,
				ignoreCase,
				"-return1",
				"Specify the glue to emit for a return statement.  The default "
				"is to place it at the beginning of a newline and place a blank "
				"after the word 'return'."
			},

			NotDependent {},
			RegularEntry {
				" { ",
				{24, 265, 39, 370},
				{24, 374, 39, 470},
				FORMATSTRING_block1,
				ignoreCase,
				"-block1",
				"Specify the glue to emit for the opening curly of a compound "
				"statement.  The default is to emit it on a line by itself and "
				"to indent the body of the compound statement."
			},

			NotDependent {},
			RegularEntry {
				" } ",
				{44, 265, 59, 370},
				{44, 374, 59, 470},
				FORMATSTRING_block2,
				ignoreCase,
				"-block2",
				"Specify the glue to emit for the closing curly of a compound "
				"statement.  The default is to align it with the opening curly "
				"on a line by itself."
			},

			NotDependent {},
			NestedDialog {
				9,
				{64, 270, 83, 365},
				"if",
				"Modify the glue for if and ifelse statements."
			},

			NotDependent {},
			NestedDialog {
				10,
				{64, 374, 83, 470},
				"switch",
				"Modify the glue for switch statements."
			},

			NotDependent {},
			NestedDialog {
				11,
				{85, 270, 104, 365},
				"for",
				"Modify the glue for switch statements."
			},

			NotDependent {},
			NestedDialog {
				12,
				{85, 374, 104, 470},
				"while/do",
				"Modify the glue for while and dowhile statements."
			},
		},


		/* #7
		**	Dialog for expression glue
		*/
		273,
		"Expression glue",
		{
			NotDependent {},
			RegularEntry {
				"  , ",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_expr1,
				ignoreCase,
				"-expr1",
				"Specify the glue for the comma operator in expressions.  The "
				"default is to emit the comma with a blank following it."
			},
			
			NotDependent {},
			RegularEntry {
				"  ? ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_expr2,
				ignoreCase,
				"-expr2",
				"Specify the glue for the question mark of the conditional "
				"expression.  The default is to surround the '?' with blanks."
			},
			
			NotDependent {},
			RegularEntry {
				" ?   : ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_expr3,
				ignoreCase,
				"-expr3",
				"Specify the glue for the colon of the conditional "
				"expression.  The default is to surround the ':' with blanks."
			},
			
			NotDependent {},
			RegularEntry {
				"  op ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_expr4,
				ignoreCase,
				"-expr4",
				"Specify the glue for an operator.  The default is to "
				"surround the operator with blanks."
			},
			
			NotDependent {},
			RegularEntry {
				"  ( ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_expr5,
				ignoreCase,
				"-expr5",
				"Specify the glue for the opening parenthesis of an expression.  "
				"The default is to emit the paren and set the indent to the first "
				"position following the paren."
			},
			
			NotDependent {},
			RegularEntry {
				"  ) ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_expr7,
				ignoreCase,
				"-expr7",
				"Specify the glue for the closing paren of an expression.  The "
				"default is to emit it as is."
			},
			
			NotDependent {},
			RegularEntry {
				"  = ",
				{24, 265, 39, 370},
				{24, 374, 39, 470},
				FORMATSTRING_expr6,
				ignoreCase,
				"-expr6",
				"Specify the glue for an assignment operator.  The default is "
				"to surround it with blanks and set the indent to the first "
				"character position following."
			},
			
			NotDependent {},
			RegularEntry {
				"  name ",
				{44, 265, 59, 370},
				{44, 374, 59, 470},
				FORMATSTRING_expr8,
				ignoreCase,
				"-expr8",
				"Specify the glue for emitting an identifier.  The default is "
				"to emit a blank before it if the last item output was an "
				"identifier."
			},
		},


		/* #8
		**	Dialog for struct glue
		*/
		273,
		"struct/class/enum/union glue",
		{
			NotDependent {},
			RegularEntry {
				" struct",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_struct0,
				ignoreCase,
				"-struct0",
				"Specify the glue for that point immediately prior to the "
				"keyword.  The default glue does nothing.",
			},

			NotDependent {},
			RegularEntry {
				"class  : ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_struct1,
				ignoreCase,
				"-struct1",
				"Specify the glue for the ':' in a class definition.  "
				"The default is to surround it with blanks and set the "
				"indent to cause all lines following it (until the opening "
				"curly) to be aligned with the ':'.",
			},

			NotDependent {},
			RegularEntry {
				"class :   , ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_struct2,
				ignoreCase,
				"-struct2",
				"Specify the glue for the comma separating the base classes "
				"for a multiple inheritance class.  The default emits the "
				"comma and places a blank after it.",
			},

			NotDependent {},
			RegularEntry {
				"struct  { ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_struct3,
				ignoreCase,
				"-struct3",
				"Specify the glue for the opening curly.  The default is "
				"to emit it on the same line as the struct &c and to indent "
				"the elements of the struct/enum/class/union.",
			},

			NotDependent {},
			RegularEntry {
				"class {  public  : ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_struct5,
				ignoreCase,
				"-struct5",
				"Specify the glue to emit for member access control keywords "
				"such as 'public', 'private', and 'protected'.  The default "
				"is to exdent them on a separate line.",
			},

			NotDependent {},
			RegularEntry {
				"struct {  } ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_struct6,
				ignoreCase,
				"-struct6",
				"Specify the glue for the closing curly of a struct.  The "
				"default is to exdent the closing curly and request a blank "
				"to follow it.",
			},

			NotDependent {},
			RegularEntry {
				"struct {  }  ;",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_struct7,
				ignoreCase,
				"-struct7",
				"Specify the glue for the semicolon of struct or enum definition.  "
				"The default glue emits two newlines after the ';'",
			},
		},

		/* #9
		**	Dialog for if/else glue
		*/
		273,
		"if glue",
		{
			NotDependent {},
			RegularEntry {
				" if",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_if0,
				ignoreCase,
				"-if0",
				"Specify the glue to emit prior to the keyword 'if'.  The "
				"default is to place the 'if' at the start of a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"if  ( ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_if1,
				ignoreCase,
				"-if1",
				"Specify the glue to emit for the opening parenthesis of the "
				"test expression.  The default is to separate from the 'if' by "
				"a blank."
			},
			
			NotDependent {},
			RegularEntry {
				"if (  )	",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_if2,
				ignoreCase,
				"-if2",
				"Specify the glue for the closing parenthesis of the test "
				"expression.  The default is to emit it as is."
			},
			
			NotDependent {},
			RegularEntry {
				"if ()  ;	",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_if3,
				ignoreCase,
				"-if3",
				"Specify the glue for the then-part of an if statement when "
				"the then-part is a semicolon.  The default is to indent it on "
				"a newline following 'if()'"
			},
			
			NotDependent {},
			RegularEntry {
				"if ()  { ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_if4,
				ignoreCase,
				"-if4",
				"Specify the glue for the opening curly of a compound statment "
				"ocurring as the then-part of an if statement.  The default is "
				"to separate it from the test expression with a single blank, "
				"request a newline and indent the body of the compound statement."
			},
			
			NotDependent {},
			RegularEntry {
				"if () {  } ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_if5,
				ignoreCase,
				"-if5",
				"Specify the glue for the closing curly of the compound "
				"statement when there is no 'else' following it.  The default "
				"is to exdent the closing curly on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"if () {  }  else",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_if6,
				ignoreCase,
				"-if6",
				"Specify the glue for the closing curly of the compound "
				"statement when an 'else' follows it.  The default "
				"is to exdent the closing curly on a newline and request a"
				"blank before the 'else'."
			},
			
			NotDependent {},
			RegularEntry {
				"if ()  ?",
				{24, 265, 39, 370},
				{24, 374, 39, 470},
				FORMATSTRING_if7,
				ignoreCase,
				"-if7",
				"Specify the glue for any other sort of statement occurring "
				"as the then-part of an if statement.  The default is to "
				"indent it on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				" else  if",
				{44, 265, 59, 370},
				{44, 374, 59, 470},
				FORMATSTRING_else1,
				ignoreCase,
				"-else1",
				"Specify the glue for 'else' when the 'else' is followed by "
				"another 'if'.  The default is to emit the 'else if' on a "
				"newline."
			},
			
			NotDependent {},
			RegularEntry {
				" else  { ",
				{64, 265, 79, 370},
				{64, 374, 79, 470},
				FORMATSTRING_else3,
				ignoreCase,
				"-else3",
				"Specify the glue for the 'else' and '{' of a compound statement "
				"occurring as the else-part of an if statement.  The default is "
				"to emit the 'else' on a newline separated from the '{' by a "
				"blank.  The body of the compound statement is indented."
			},
			
			NotDependent {},
			RegularEntry {
				"else {  } ",
				{84, 265, 99, 370},
				{84, 374, 99, 470},
				FORMATSTRING_else6,
				ignoreCase,
				"-else6",
				"Specify the glue for the closing curly of the compound "
				"statement occurring as the else-part of an if statement.  The "
				"default is to exdent the closing curly on a line by itself."
			},
			
			NotDependent {},
			RegularEntry {
				"  else  ?",
				{104, 265, 119, 370},
				{104, 374, 119, 470},
				FORMATSTRING_else4,
				ignoreCase,
				"-else4",
				"Specify the glue for the 'else' when the 'else' is followed "
				"by something other than an 'if' or opening curly.  The default "
				"is to emit the 'else' on a line by itself with the else-part "
				"indented on the line following."
			},
		},

		/* #10
		**	Dialog for switch glue
		*/
		273,
		"switch glue",
		{
			NotDependent {},
			RegularEntry {
				" switch",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_switch0,
				ignoreCase,
				"-switch0",
				"Specify the glue to emit prior to the switch statement.  The "
				"default is to request it to be on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"switch  ( ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_switch1,
				ignoreCase,
				"-switch1",
				"Specify the glue for the open parenthesis of the switch "
				"statement's selection expression.  The default is to separate "
				"it from the 'switch' by a blank."
			},
			
			NotDependent {},
			RegularEntry {
				"switch ()  { ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_switch2,
				ignoreCase,
				"-switch2",
				"Specify the glue for the open curly of the body of the "
				"switch statement.  The default is to cuddle it on the same "
				"line as the selection expression, separating it from the ')' "
				"with a blank and indenting the body of the switch."
			},
			
			NotDependent {},
			RegularEntry {
				"switch () {  } ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_switch7,
				ignoreCase,
				"-switch7",
				"Specify the glue for the close curly of a switch statement.  "
				"The default is to exdent it on its own newline."
			},
			
			NotDependent {},
			RegularEntry {
				" case ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_switch3,
				ignoreCase,
				"-switch3",
				"Specify the glue to emit for the 'case' reserved word.  "
				"The default is to exdent it on its own newline and follow "
				"it with a blank."
			},
			
			NotDependent {},
			RegularEntry {
				" default ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_switch4,
				ignoreCase,
				"-switch4",
				"Specify the glue to emit for the 'default' reserved word.  "
				"The default is to exdent the 'default' on its own newline."
			},
			
			NotDependent {},
			RegularEntry {
				"case nnn  : ",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_switch5,
				ignoreCase,
				"-switch5",
				"Specify the glue for the colon following any case label, "
				"including 'default'.  The default is to cuddle it with the "
				"token on its left and request a newline to follow it."
			},
		},

		/* #11
		**	Dialog for for glue
		*/
		273,
		"for glue",
		{
			NotDependent {},
			RegularEntry {
				" for",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_for0,
				ignoreCase,
				"-for0",
				"Specify the glue to emit prior to a for statement.  The "
				"default is to request it to be on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"for  ( ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_for1,
				ignoreCase,
				"-for1",
				"Specify the glue to emit for the opening parenthesis of the "
				"test expression of a for statement.  The default is to emit "
				"it as is."
			},
			
			NotDependent {},
			RegularEntry {
				"for (  ;",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_for3,
				ignoreCase,
				"-for3",
				"Specify the glue for semicolon in the test "
				"expression of a for statement.  The default is to cuddle it"
				"with the previous token and request a blank to follow it."
			},
			
			NotDependent {},
			RegularEntry {
				"for (  ) ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_for4,
				ignoreCase,
				"-for4",
				"Specify the glue for the close parenthesis of the test "
				"expression of a for statement.  The default is to just "
				"emit it as is."
			},
			
			NotDependent {},
			RegularEntry {
				"for ()  { ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_for5,
				ignoreCase,
				"-for5",
				"Specify the glue for the open curly of a compound statement "
				"for-body.  The default is to separate it from the test "
				"expression with a single blank and indent the body."
			},
			
			NotDependent {},
			RegularEntry {
				"for () {  } ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_for8,
				ignoreCase,
				"-for8",
				"Specify the glue for the close curly of the compound statement "
				"for-body.  The default is to exdent it on its own newline."
			},
			
			NotDependent {},
			RegularEntry {
				"for ()  ; ",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_for6,
				ignoreCase,
				"-for6",
				"Specify the glue for an empty for-body.  The default is to "
				"indent the semicolon on its own newline."
			},
			
			NotDependent {},
			RegularEntry {
				"for ()  ?",
				{24, 265, 39, 370},
				{24, 374, 39, 470},
				FORMATSTRING_for7,
				ignoreCase,
				"-for7",
				"Specify the glue to emit prior to an arbitrary for body "
				"statement.  The default is to indent the statement on its "
				"own newline."
			},
		},

		/* #12
		**	Dialog for while/do glue
		*/
		273,
		"while/do glue",
		{
			NotDependent {},
			RegularEntry {
				" while",
				{24,  10, 39, 141},
				{24, 145, 39, 250},
				FORMATSTRING_while0,
				ignoreCase,
				"-while0",
				"Specify the glue to emit prior to the 'while'.  The default "
				"is to request the while on its own line."
			},
			
			NotDependent {},
			RegularEntry {
				"while  ( ",
				{44,  10, 59, 141},
				{44, 145, 59, 250},
				FORMATSTRING_while1,
				ignoreCase,
				"-while1",
				"Specify the glue to emit for the opening parenthesis of the "
				"test expression of a while statement.  The default is to put "
				"it on the same line as the 'while' with a blank separating "
				"the two."
			},
			
			NotDependent {},
			RegularEntry {
				"while (  ) ",
				{64,  10, 79, 141},
				{64, 145, 79, 250},
				FORMATSTRING_while6,
				ignoreCase,
				"-while6",
				"Specify the glue for the close parenthesis of the test "
				"expression.  The default is to emit it as is."
			},
			
			NotDependent {},
			RegularEntry {
				"while ()  ; ",
				{84,  10, 99, 141},
				{84, 145, 99, 250},
				FORMATSTRING_while3,
				ignoreCase,
				"-while3",
				"Specify the glue for an empty while body.  The default is to "
				"place it indented on its own newline."
			},
			
			NotDependent {},
			RegularEntry {
				"while ()  { ",
				{104,  10, 119, 141},
				{104, 145, 119, 250},
				FORMATSTRING_while2,
				ignoreCase,
				"-while2",
				"Specify the glue for the opening curly of a compound statement "
				"while body.  The default is to separate it from the test expression "
				"by a single blank and indent the body."
			},
			
			NotDependent {},
			RegularEntry {
				"while () {ʥ } ",
				{124,  10, 139, 141},
				{124, 145, 139, 250},
				FORMATSTRING_while5,
				ignoreCase,
				"-while5",
				"Specify the glue for the closing curly of a compound statement "
				"while body.  The default is to exdent it on its own newline."
			},
			
			NotDependent {},
			RegularEntry {
				"while ()  ?",
				{144,  10, 159, 141},
				{144, 145, 159, 250},
				FORMATSTRING_while4,
				ignoreCase,
				"-while4",
				"Specify the glue for any other statement as the body of a "
				"while.  The default is to indent the statement on its own "
				"newline."
			},
			
			NotDependent {},
			RegularEntry {
				" do",
				{24, 265, 39, 370},
				{24, 374, 39, 470},
				FORMATSTRING_do0,
				ignoreCase,
				"-do0",
				"Specify the glue to emit prior to the 'do' of a dowhile.  "
				"The default is to begin the statement on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"do  ;",
				{44, 265, 59, 370},
				{44, 374, 59, 470},
				FORMATSTRING_do1,
				ignoreCase,
				"-do1",
				"Specify the glue for a dowhile body consisting of a single "
				"semicolon.  The default is to indent it on its own line."
			},
			
			NotDependent {},
			RegularEntry {
				"do  { ",
				{64, 265, 79, 370},
				{64, 374, 79, 470},
				FORMATSTRING_do2,
				ignoreCase,
				"-do2",
				"Specify the glue for the opening curly of a compound statement "
				"body in a dowhile.  The default is to request a blank and "
				"put it on the same line as the 'do'.  The body will be indented."
			},
			
			NotDependent {},
			RegularEntry {
				"do {  } ",
				{84, 265, 99, 370},
				{84, 374, 99, 470},
				FORMATSTRING_do4,
				ignoreCase,
				"-do4",
				"Specify the glue for the closing curly of the compound "
				"statement body of a dowhile.  The default is to exdent the "
				"curly, request a blank, and cuddle the 'while' on the same "
				"line"
			},
			
			NotDependent {},
			RegularEntry {
				"do  ?",
				{104, 265, 119, 370},
				{104, 374, 119, 470},
				FORMATSTRING_do3,
				ignoreCase,
				"-do3",
				"Specify the glue prior to a non-compound statement.  The "
				"default is to indent the statement on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"do  while",
				{124, 265, 139, 370},
				{124, 374, 139, 470},
				FORMATSTRING_do5,
				ignoreCase,
				"-do5",
				"Specify the glue to emit for the 'while' in a dowhile.  The "
				"default is to place the 'while' on a newline."
			},
			
			NotDependent {},
			RegularEntry {
				"dowhile  ( ",
				{144, 265, 159, 370},
				{144, 374, 159, 470},
				FORMATSTRING_do6,
				ignoreCase,
				"-do6",
				"Specify the glue for the open parenthesis of the test "
				"expression of the 'do'.  The default is to emit a blank and "
				"then the open parenthesis."
			},
		},
	},
};
